#!/usr/bin/python2.5
class line_tool():
	x1=0;y1=0
	def move(self):
		None
	def touch(self):
		self.x1=int(x)
		self.y1=int(y)
	def release_i(self):
		line_x=self.x1;line_y=self.y1
		x2=x;y2=float(y)
		xd=line_x-x2
		yd=line_y-y2
		if abs(yd)>abs(xd):
			x_inc=float(xd)/float(abs(yd))
			slope=(yd)/abs(yd)
			while y2!=line_y:
				fscreen.seek((x2+800*int(y2))*2)
				inverse="".join(chr(~ord(a)+256) for a in fscreen.read(2))
				fscreen.seek(-2,1)
				fscreen.write(inverse)
				#fscreen.write(chr(0xFF)*2)
				x2+=x_inc;y2+=slope
		elif xd==0:
			return
		else:
			x_inc=(xd)/abs(xd)
			slope=float(yd)/float(abs(xd))
			while x2!=line_x:
				fscreen.seek((x2+800*int(y2))*2)
				inverse="".join(chr(~ord(a)+256) for a in fscreen.read(2))
				fscreen.seek(-2,1)
				fscreen.write(inverse)
				#fscreen.write(chr(0xFF)*2)
				x2+=x_inc;y2+=slope
		global need_refresh;need_refresh=True
	def release_normal(self):
		line_x=self.x1;line_y=self.y1
		x2=x;y2=float(y)
		xd=line_x-x2
		yd=line_y-y2
		if abs(yd)>abs(xd):
			x_inc=float(xd)/float(abs(yd))
			slope=(yd)/abs(yd)
			while y2!=line_y:
				fscreen.seek((x2+800*int(y2))*2)
				fscreen.write(chr(0xFF)*2)
				x2+=x_inc;y2+=slope
		elif xd==0:
			return
		else:
			x_inc=(xd)/abs(xd)
			slope=float(yd)/float(abs(xd))
			while x2!=line_x:
				fscreen.seek((x2+800*int(y2))*2)
				fscreen.write(chr(0xFF)*2)
				x2+=x_inc;y2+=slope
		global need_refresh;need_refresh=True
	release=release_i
line_tool=line_tool()

WIDTH, HEIGHT = 600, 800
def in_region(tool,mem):
	region=tool.region
	if mem<region[0] or region[1]<mem: return False
	memx=mem%HEIGHT
	return (region[0]%HEIGHT<=memx and memx<=region[1]%HEIGHT)

class button_tool():
	square=WIDTH/16
	center=(WIDTH%16)/2
	
	region=[HEIGHT*(center+1)-square*8-center,HEIGHT*(square*16+center+1)-center]
	def move(self):
		fscreen.seek((x+HEIGHT*y)*2)
		fscreen.write(chr(0xFF)*2)
		global need_refresh;need_refresh=True
	
	def touch(self):
		square,center=self.square,self.center
		y1=y-(y-center)%square
		x1=x-(x-(HEIGHT-center))%square
		char=chr(0x7F&(0x10*(x1-(HEIGHT-square*10-center))/square+15-(y1-center)/square))
		display_tool.printc(char)
		try: print char
		except: None
		fscreen.seek((x1+HEIGHT*y1)*2)
		count=0
		while count<square-1:
			inverse="".join(chr(~ord(a)+256) for a in fscreen.read(36*2))
			fscreen.seek(-36*2,1)
			fscreen.write(inverse)
			fscreen.seek((800-36)*2,1)
			count+=1
		global need_refresh;need_refresh=True
		if char==chr(0x1F):
			while need_refresh: None
			exit()
	
	def release(self):
		None
button_tool=button_tool()

class display_tool():
	maxtop=17
	maxwidth=21
	#fycenter=10
	#fxcenter=10
	boundx=(HEIGHT-button_tool.square*8-button_tool.center)/maxtop
	boundy=WIDTH/maxwidth
	curx=0
	cury=boundy-1
	def printc(self,char):
		maxtop,maxwidth,boundx,boundy,curx,cury=self.maxtop,self.maxwidth,self.boundx,self.boundy,self.curx,self.cury
		##char=chr(0x10*(x1-(HEIGHT-square*10-center))/square+15-(y1-center)/square)
		ordc=min(ord(char),0x7F)
		if ordc<0x20: ordc=0x7F
		x1=HEIGHT-button_tool.center-button_tool.square*10+((ordc&0xF0)>>4)*button_tool.square;y1=(15-(ordc&0x0F))*button_tool.square+button_tool.center
		fkeys.seek((x1+14+HEIGHT*(y1+8))*2)
		fscreen.seek((curx*maxtop+HEIGHT*cury*maxwidth)*2)
		count=0
		while count<maxwidth:
			inverse=fkeys.read(maxtop*2)
			fscreen.write(inverse)
			fkeys.seek((HEIGHT-maxtop)*2,1)
			fscreen.seek((HEIGHT-maxtop)*2,1)
			count+=1
		self.cury-=1
		self.bound()
	def bound(self):
		boundx,boundy=self.boundx,self.boundy
		if self.cury<0:
			self.cury=boundy-1
			self.curx+=1;self.curx%=boundx
	box=chr(0xFF)*2+chr(0x00)*(maxtop-2)*2+chr(0xFF)*2
	box_lr=chr(0xFF)*maxtop*2
	def draw_box(self,length):
		maxtop,maxwidth,boundx,boundy,curx,cury=self.maxtop,self.maxwidth,self.boundx,self.boundy,self.curx,self.cury
		fscreen.seek((curx*maxtop+HEIGHT*(cury-length)*maxwidth)*2)
		fscreen.write(self.box_lr)
		fscreen.seek((HEIGHT-maxtop)*2,1)
		count=1
		while count<maxwidth*length-1:
			fscreen.write(self.box)
			fscreen.seek((HEIGHT-maxtop)*2,1)
			count+=1
		fscreen.write(self.box_lr)
		#self.cury-=length
		#self.bound()
	def printline(self,line):
		boundx,boundy=self.boundx,self.boundy
		i,length=0,len(line)
		while i<length:
			c=line[i];i+=1
			if c=='\r':
				self.draw_box(self.cury+1)
				self.cury=boundy-1
				if line[i+1]!='\n':
					self.curx+=1
					self.curx%=boundx
			elif c=='\n':
				if line[i-1]!='\r': self.draw_box(self.cury);self.cury=boundy-1
				self.curx+=1;self.curx%=boundx
			else:
				self.printc(c)
			if self.curx==0 and self.cury==boundy-1:
				return
	def printlines(self,lines):
		for line in lines:
			if -1<line.find('\t'): print "tab found"
			self.printline(line)
			if self.curx==0 and self.cury==self.boundy-1:
				return lines.index(line)
		return len(lines)
	x1=0;y1=0
	def move(self):
		None
	def touch(self):
		self.x1=int(x)
		self.y1=int(y)
	def release(self):
		line_x=self.x1;line_y=self.y1
		x2=x;y2=float(y)
		xd=line_x-x2
		yd=line_y-y2
		if abs(xd)>100:
			x_inc=(xd)/abs(xd)
			if x_inc==-1: browse_tool.lseek=int(browse_tool.lseekup)
			browse_tool.load()
		else:
			curx,cury,maxtop,maxwidth=self.curx,self.cury,self.maxtop,self.maxwidth
			line_tool.x1,line_tool.y1=x-(x%maxtop),y-(y%maxwidth)+maxwidth
			global x,y;x,y=line_tool.x1+maxtop,line_tool.y1
			line_tool.release()
		global need_refresh;need_refresh=True
display_tool=display_tool()

class browse_tool():
	filename="/mnt/onboard/nickel.py"
	filelines=open(filename).readlines()
	lseekup=0
	lseek=0
	def load(self):
		lseek=self.lseek
		print 'seek:',lseek
		self.lseekup=int(lseek)
		self.lseek=1+display_tool.printlines(self.filelines[lseek:])
	def move(self):
		None
	def touch(self):
		None
	def release(self):
		None
browse_tool=browse_tool()

#class _tool():
#	def move(self):
#		None
#	def touch(self):
#		None
#	def release(self):
#		None
#_tool=_tool()

#class passw_tool():
#	def move(self):
#		None
#	def touch(self):
#		os.popen("sleep 30")
#		import sys
#		os.popen("kill -s 18 "+str(sys.argv[2]))
#		global tool;tool=line_tool
#		thread.start_new_thread(refresh_screen, ())
#	def release(self):
#		None
#passw_tool=passw_tool()

def move():
	if in_region(button_tool,x+y*HEIGHT): button_tool.move()
	else: tool.move()
def touch():
	if in_region(button_tool,x+y*HEIGHT): button_tool.touch()
	else: tool.touch()
def release():
	if in_region(button_tool,x+y*HEIGHT): button_tool.release()
	else: tool.release()
#execfile("/mnt/onboard/toolbox.py")
tool=display_tool
import thread, os
fscreen=open("/mnt/onboard/screen.raw","rb+")
fkeys=open("/mnt/onboard/keys.raw","rb")
#browse_tool.load()
def refresh_screen():
	global need_refresh
	while True:
		if need_refresh==True:
			need_refresh=False
			#fscreen.flush()
			os.popen("cat /mnt/onboard/screen.raw | /usr/local/Kobo/pickel showpic 1")
need_refresh=True
thread.start_new_thread(refresh_screen, ())

import struct
file=open("/dev/input/event1","rb")
x=0;y=0;touched=False;touching=False
while True:
	(sec, usec, type, code, value) = struct.unpack("iihhi",file.read(16))
	if type == 0:
		if touched:
			if touching: release()
			else: touch()
			touching = not touching
		else:
			move()
			touching=True
		touched=False
	elif type == 1:
		touched = True
	elif type == 3:
		if code == 0: x = value
		if code == 1: y = value