#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>

#define MOD(a,b) (((a)+(b))%(b))
#define min(a,b) ((a)<(b)?(a):(b))
#define max(a,b) ((a)>(b)?(a):(b))

struct image
	char *fn
	int fd
	int w,h,p
	int bypp
	char *tc
;//
#define image struct image
struct string
	char* str
	int len
;//
#define string struct string
void print_string(string s,char *fmt)
	//fmt="%x","%c","%X"
	if(!fmt)fmt="%x"
	static int i ;i=0
	while(1)
		printf(fmt,*(s.str+i))
		i+=1 ;if(i>=s.len) break
	printf("\n")

string read_image(image o,int x,int y,int n)
void write_image(image o,int x,int y,string s,char *tc)
image new_image(char *fn,int w,int h,int p,int bypp,char *tc)
	image o
	o.fn=fn ;o.fd=-1
	o.w=w ;o.h=h ;o.p=p
	o.bypp=bypp ;o.tc=tc
	//o.read=&read_image ;o.write=&write_image
	return o
string read_image(image o,int x,int y,int n)
	static int x1,y1,n1
	x1=MOD(x,o.w) ;y1=MOD(y,o.h)
	n1=min(n,o.w-x)
	static string s ;s.str=malloc(n1*o.bypp) ;s.len=0
	if(x1==x && y1==y)
		lseek(o.fd,(y*o.p+x)*o.bypp,0)
		s.len=read(o.fd,s.str,n1*o.bypp)
	return s
void write_image(image o,int x,int y,string s,char *tc)
	static int x1,y1,n,n1,i
	static char *u ;u=malloc(o.bypp) ;//*sizeof(char)
	n=s.len/o.bypp
	x1=MOD(x,o.w) ;y1=MOD(y,o.h)
	n1=min(n,o.w-x)
	if(x1==x && y1==y)
		lseek(o.fd,(y*o.p+x)*o.bypp,0)
		//o.f.write(s[:n1*o.bypp])
		i=0
		while(i<n1)
			strncpy(u,(s.str+i*o.bypp),o.bypp)
			if(!tc||memcmp(u,tc,o.bypp)) write(o.fd,u,o.bypp)
			else lseek(o.fd,o.bypp,1)
			i+=1
		free(u)
	else {free(u);return;}
//#def readm
//#def writem
void directfb_copy(image* s,image *d,int x,int y,char *tc)
	#define s (*s)
	#define d (*d)
	if(d.fd<0) d.fd=open(d.fn,O_RDWR)
	if(s.fd<0) s.fd=open(s.fn,O_RDWR)
	//printf("fd  %d %d\n",s.fd ,d.fd)
	static int w,h
	string scl
	w=0 ;h=0
	while(h<s.h)
		scl=read_image(s,w,h,s.w)
		write_image(d,x+w,y+h,scl,tc)
		//print_string(scl,NULL)
		h+=1
		free(scl.str)
	#undef s
	#undef d
void directfb_copyfrom(image* d,image* s,int x,int y,char *tc)
	#define s (*s)
	#define d (*d)
	if(d.fd<0) d.fd=open(d.fn,O_RDWR)
	if(s.fd<0) s.fd=open(s.fn,O_RDWR)
	static int w,h
	string scl
	w=0 ;h=0
	while(h<d.h)
		scl=read_image(s,x+w,y+h,d.w)
		write_image(d,w,h,scl,tc)
		h+=1
		free(scl.str)
	#undef s
	#undef d
image fb,curs1,curs1b
int mm_skip=0
int mm_x=-1 ;int mm_y=-1
void mm_f(int x,int y)
	//#static int mm_skip,mm_x,mm_y
	static int x2,y2
	mm_skip=(mm_skip+1)%10
	if(mm_skip) return
	x2=y-15/2 ;y2=screen.w-x-15/2
	if(mm_x==-1||!(mm_x==x2&&mm_y==y2))
		if(mm_x!=-1) directfb_copy(&curs1b,&fb,mm_x,mm_y,NULL)
		mm_x=x2 ;mm_y=y2
		directfb_copyfrom(&curs1b,&fb,mm_x,mm_y,NULL)
	directfb_copy(&curs1,&fb,mm_x,mm_y,"\xFF\xFF")
	//close(fb.fd) ;close(curs1.fd)

void gfx_init()
	fb=new_image("/dev/fb0",800,600,800,2,NULL)
	curs1=new_image("cursor1.raw",15,15,15,2,NULL)
	curs1b=new_image("cursor1b.raw",15,15,15,2,NULL)
void main0()
	gfx_init()
	directfb_copy(&curs1,&fb,400,400,"\xFF\xFF")
